tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > > Class Template Reference

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >:
Collaboration diagram for tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >:

## Public Types

typedef tbb::flow::tuple< receiver< InputTypes > &... > | input_ports_type
typedef tbb::flow::tuple< sender< OutputTypes > &... > | output_ports_type

## Public Member Functions

| composite_node (graph &g)
template<typename T1 , typename T2 >
void | set_external_ports (T1 &&input_ports_tuple, T2 &&output_ports_tuple)
template<typename... NodeTypes>
void | add_visible_nodes (const NodeTypes &... n)
template<typename... NodeTypes>
void | add_nodes (const NodeTypes &... n)
input_ports_type & | input_ports ()
output_ports_type & | output_ports ()
Public Member Functions inherited from tbb::flow::interface11::graph_node
| graph_node (graph &g)
virtual | ~graph_node ()

## Protected Member Functions

void | reset_node (reset_flags) __TBB_override

## Private Attributes

std::unique_ptr< input_ports_type > | my_input_ports
std::unique_ptr< output_ports_type > | my_output_ports

## Static Private Attributes

static const size_t | NUM_INPUTS = sizeof...(InputTypes)
static const size_t | NUM_OUTPUTS = sizeof...(OutputTypes)

## Additional Inherited Members

Protected Attributes inherited from tbb::flow::interface11::graph_node
graph & | my_graph
graph_node * | next
graph_node * | prev

## Detailed Description

### template<typename... InputTypes, typename... OutputTypes>
class tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >

Definition at line 3594 of file flow_graph.h.

## Member Typedef Documentation

## input_ports_type

template<typename... InputTypes, typename... OutputTypes>

typedef tbb::flow::tuple< receiver<InputTypes>&... > tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::input_ports_type

Definition at line 3597 of file flow_graph.h.

## output_ports_type

template<typename... InputTypes, typename... OutputTypes>

typedef tbb::flow::tuple< sender<OutputTypes>&... > tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::output_ports_type

Definition at line 3598 of file flow_graph.h.

## Constructor & Destructor Documentation

## composite_node()

template<typename... InputTypes, typename... OutputTypes>

tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::composite_node | ( | graph & | g | ) |

inline

Definition at line 3617 of file flow_graph.h.

: graph_node(g) {
tbb::internal::fgt_multiinput_multioutput_node( CODEPTR(), tbb::internal::FLOW_COMPOSITE_NODE, this, &this->my_graph );
}

References CODEPTR, and tbb::internal::fgt_multiinput_multioutput_node().

Here is the call graph for this function:

## Member Function Documentation

## add_nodes()

template<typename... InputTypes, typename... OutputTypes>
template<typename... NodeTypes>

void tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::add_nodes | ( | const NodeTypes &... | n | ) |

inline

Definition at line 3637 of file flow_graph.h.

{ internal::add_nodes_impl(this, false, n...); }

References internal::add_nodes_impl().

Here is the call graph for this function:

## add_visible_nodes()

template<typename... InputTypes, typename... OutputTypes>
template<typename... NodeTypes>

void tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::add_visible_nodes | ( | const NodeTypes &... | n | ) |

inline

Definition at line 3634 of file flow_graph.h.

{ internal::add_nodes_impl(this, true, n...); }

References internal::add_nodes_impl().

Here is the call graph for this function:

## input_ports()

template<typename... InputTypes, typename... OutputTypes>

input_ports_type& tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::input_ports | ( |  | ) |

inline

Definition at line 3645 of file flow_graph.h.

{
__TBB_ASSERT(my_input_ports, "input ports not set, call set_external_ports to set input ports");
return *my_input_ports;
}

References __TBB_ASSERT.

## output_ports()

template<typename... InputTypes, typename... OutputTypes>

output_ports_type& tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::output_ports | ( |  | ) |

inline

Definition at line 3650 of file flow_graph.h.

{
__TBB_ASSERT(my_output_ports, "output ports not set, call set_external_ports to set output ports");
return *my_output_ports;
}

References __TBB_ASSERT.

## reset_node()

template<typename... InputTypes, typename... OutputTypes>

void tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::reset_node | ( | reset_flags |  | ) |

inline protected virtual

Implements tbb::flow::interface11::graph_node.

Definition at line 3608 of file flow_graph.h.

{}

## set_external_ports()

template<typename... InputTypes, typename... OutputTypes>
template<typename T1 , typename T2 >

void tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::set_external_ports | ( | T1 && | input_ports_tuple,
|  | T2 && | output_ports_tuple
| ) |  |

inline

Definition at line 3623 of file flow_graph.h.

{
__TBB_STATIC_ASSERT(NUM_INPUTS == tbb::flow::tuple_size<input_ports_type>::value, "number of arguments does not match number of input ports");
__TBB_STATIC_ASSERT(NUM_OUTPUTS == tbb::flow::tuple_size<output_ports_type>::value, "number of arguments does not match number of output ports");
my_input_ports = tbb::internal::make_unique<input_ports_type>(std::forward<T1>(input_ports_tuple));
my_output_ports = tbb::internal::make_unique<output_ports_type>(std::forward<T2>(output_ports_tuple));
tbb::internal::fgt_internal_input_alias_helper<T1, NUM_INPUTS>::alias_port( this, input_ports_tuple);
tbb::internal::fgt_internal_output_alias_helper<T2, NUM_OUTPUTS>::alias_port( this, output_ports_tuple);
}

References __TBB_STATIC_ASSERT, tbb::internal::fgt_internal_input_alias_helper< PortsTuple, N >::alias_port(), tbb::internal::fgt_internal_output_alias_helper< PortsTuple, N >::alias_port(), and value.

Here is the call graph for this function:

## Member Data Documentation

## my_input_ports

template<typename... InputTypes, typename... OutputTypes>

std::unique_ptr<input_ports_type> tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::my_input_ports

private

Definition at line 3601 of file flow_graph.h.

## my_output_ports

template<typename... InputTypes, typename... OutputTypes>

std::unique_ptr<output_ports_type> tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::my_output_ports

private

Definition at line 3602 of file flow_graph.h.

## NUM_INPUTS

template<typename... InputTypes, typename... OutputTypes>

const size_t tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::NUM_INPUTS = sizeof...(InputTypes)

static private

Definition at line 3604 of file flow_graph.h.

## NUM_OUTPUTS

template<typename... InputTypes, typename... OutputTypes>

const size_t tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::NUM_OUTPUTS = sizeof...(OutputTypes)

static private

Definition at line 3605 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

CODEPTR
#define CODEPTR()
Definition: _flow_graph_trace_impl.h:297
tbb::internal::fgt_multiinput_multioutput_node
static void fgt_multiinput_multioutput_node(void *, string_index, void *, void *)
Definition: _flow_graph_trace_impl.h:324
tbb::flow::interface11::graph_node::graph_node
graph_node(graph &g)
Definition: flow_graph.h:880
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::NUM_INPUTS
static const size_t NUM_INPUTS
Definition: flow_graph.h:3604
tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::NUM_OUTPUTS
static const size_t NUM_OUTPUTS
Definition: flow_graph.h:3605
tbb::internal::fgt_internal_output_alias_helper::alias_port
static void alias_port(void *, PortsTuple &)
Definition: _flow_graph_trace_impl.h:356
tbb::flow::interface11::graph_node::my_graph
graph & my_graph
Definition: _flow_graph_impl.h:464
__TBB_STATIC_ASSERT
#define __TBB_STATIC_ASSERT(condition, msg)
Definition: tbb_stddef.h:553
internal::add_nodes_impl
void add_nodes_impl(CompositeType *, bool)
Definition: _flow_graph_node_impl.h:958
tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::my_input_ports
std::unique_ptr< input_ports_type > my_input_ports
Definition: flow_graph.h:3601
tbb::internal::fgt_internal_input_alias_helper::alias_port
static void alias_port(void *, PortsTuple &)
Definition: _flow_graph_trace_impl.h:351
tbb::flow::interface11::composite_node< tbb::flow::tuple< InputTypes... >, tbb::flow::tuple< OutputTypes... > >::my_output_ports
std::unique_ptr< output_ports_type > my_output_ports
Definition: flow_graph.h:3602
value
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain __itt_id ITT_FORMAT p const __itt_domain __itt_id __itt_timestamp __itt_timestamp ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain ITT_FORMAT p const __itt_domain __itt_string_handle unsigned long long value
Definition: ittnotify_static.h:192

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.